
//--------------------ݒ--------------------------------------------------

#include "std.mi"
#include "attribs.m"

/*******************************************************************************
//      ֐錾
*******************************************************************************/

Function fn_setVolumeAnim(int volValue); //{[̕\ύX
Function fn_updateVolume(int x, int y);  //{[̕ύXl̊o

/*******************************************************************************
//      O[o֐錾
*******************************************************************************/

Global Group		glpVolume;
Global Layer		lyrVolume;
Global Button		btnMute;
Global Map		mapVolMap;
Global Map		mapVolMap2;
Global Boolean		blnVolumeChanging;     //hbO`FbN
Global Boolean		blnMute;
Global Int		intVolume;
/*******************************************************************************
//      #System.onScriptLoaded()
//      XNvgNɎs
//      ݒ
*******************************************************************************/

System.onScriptLoaded() {

	initAttribs();

        // IuWFNgݒ
        glpVolume  = getScriptGroup();
        lyrVolume  = glpVolume.findObject("volume");
	btnMute    = glpVolume.findObject("mute");

        //  }bvݒ
        mapVolMap = new Map;
        mapVolMap.loadMap("player.volume.map.click");
        mapVolMap2 = new Map;
        mapVolMap2.loadMap("player.volume.map.drag");

        // Ñ{[lɏ]{[o[̕\XV
        fn_setVolumeAnim(System.getVolume());
}


/*******************************************************************************
//      #System.onScriptUnLoaded()
//      XNvgIɎs
*******************************************************************************/

System.onScriptUnloading() {
        delete mapVolMap;
        delete mapVolMap2;
}

/*******************************************************************************
//      #System.onVolumeChanged(
//        int newVol    //ύX̒l
//      )
//      F{[ύXꂽɌĂяo
//      @\FύXꂽlɏ]{[\̍XVAl̕\
*******************************************************************************/

System.onVolumeChanged(int newVol) {
        fn_setVolumeAnim(newVol);


	if (blnMute && newVol == 0) return;

	blnMute = 0;
	btnMute.setXmlParam("image", "volume0");

}

/*******************************************************************************
//      #btnMute.onLeftClick()
//      F~[g{^NbNꂽ
//      @\F~[g؂ւ
*******************************************************************************/

btnMute.onLeftClick() {

	if (!blnMute) {
	  volume_mute_attrib.setData("1");
	  blnMute = 1;
	  intVolume = getVolume();
          setVolume(0);
	  btnMute.setXmlParam("image", "volume1");
	} else {
	  volume_mute_attrib.setData("0");
	  blnMute = 0;
          setVolume(intVolume);
	  btnMute.setXmlParam("image", "volume0");
	}
}

/*******************************************************************************
//      #lyrVolume.onLeftButtonDown(
//        int x         //X
//        int y         //Y
//      )
//      F{[IuWFNg
//            }EX̍{^ꂽɌĂяo
//      @\FmapVolMap͈͓̔Ȃ΁AtO(blnVolumeChanging)ONɂāA
//            {[̕ύXJn
*******************************************************************************/

lyrVolume.onLeftButtonDown(int x, int y) {
        if (mapVolMap.inRegion(x - lyrVolume.getLeft(), y - lyrVolume.getTop())) {
	  blnVolumeChanging = 1;
	  fn_updateVolume(x, y);

		if (blnMute) {
		  blnMute = 0;
		  btnMute.setXmlParam("image", "volume0");
		}
        }


}


/*******************************************************************************
//      #lyrVolume.onLeftButtonUp(
//        int x         //X
//        int y         //Y
//      )
//      F{[IuWFNg
//            }EX̍{^ꂽɌĂяo
//      @\FtO(blnVolumeChanging)ONȂA{[ύX
*******************************************************************************/

lyrVolume.onLeftButtonUp(int x, int y) {
        if (!blnVolumeChanging) return;

        if (y - lyrVolume.getTop() <= 0) y = lyrVolume.getTop() + 0;

	blnVolumeChanging = 0;
	fn_updateVolume(x, y);
}


/*******************************************************************************
//      #lyrVolume.onMouseMove(
//        int x         //X
//        int y         //Y
//      )
//      F{[IuWFNgŃ}EXɌĂяo
//      @\FmapVolMap2͈͓ŃtO(blnVolumeChanging)ONȂA{[̕ύX
*******************************************************************************/

lyrVolume.onMouseMove(int x, int y) {

	if (!blnVolumeChanging) return;

        if (y - lyrVolume.getTop() <= 0) y = lyrVolume.getTop() + 0;
	fn_updateVolume(x, y);

}

/*--------------֐------------------------------------------------------*/

/*******************************************************************************
//      #fn_setVolumeAnim(
//        int    Value        //{[̒l
//      )
//      @\F{[̒lɏ] lyrVolume ̕\ύX
*******************************************************************************/

fn_setVolumeAnim(int Value) {
        Region r = new Region;
        r.loadFromMap(mapVolMap2, Value, 1);
        lyrVolume.setRegion(r);
        delete r;
}


/*******************************************************************************
//      #fn_updateVolume(
//        int    x        //}EẌʒu(X)
//        int    y        //}EẌʒu(Y)
//      )
//      @\F}EXʒu mapVolMap2 {[l擾
*******************************************************************************/

fn_updateVolume(int x, int y) {
          int newValue = mapVolMap2.getValue(1,y - lyrVolume.getTop());
          System.setVolume(newValue);
}

